/***
 * Excerpted from "Domain-Driven Design Using Naked Objects",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material, 
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/dhnako for more book information.
***/
package com.pragprog.dhnako.carserv.dom.service;

import org.nakedobjects.applib.spec.AbstractSpecification;

public class BookedInBeforeEstReadySpecification extends AbstractSpecification<Service> {

	@Override
	public String satisfiesSafely(final Service service) {
		return service.getEstimatedReady() != null &&
		   	   service.getBookedIn()       != null &&
		       service.getEstimatedReady().getTime() < 
		       			service.getBookedIn().getTime() ?
		       "The 'estimated ready' date cannot be before "+
		       "the 'booked in' date"
		       :null;
	}

}
